;
;******************************************************************************
;
; ----------------------------Support procedures------------------------------ 
;
;******************************************************************************
;
pro ximgtool_startup,WID=wid,GROUP_LEADER=group_leader

mkct
font='7x14'

common ximgtool_state, state,main_image

;  Build the structures which will hold the important info.
;  w - contains info pertaining to widget operations.

w = {cbarwin:0L,$
     hdr_base:0L,$
     hdr_text:0L,$
     keyboard:0L,$
     plot_base:0,$
     plotwin:0L,$
     track:0L,$
     ximgtool_base:0L}

p = {blue:ptr_new(fltarr(2)),$
     brightness:500.,$
     buffer:[0,0],$
     cbarwin_wid:0L,$
     cenpix:[0.,0.],$
     contrast:500.,$
     cursor:[0.8,0.02],$
     cursormode:'None',$
     dev2img:0.,$
     firstclick:0,$
     green:ptr_new(fltarr(2)),$
     imagescaling:'Linear',$
     maxbandc:1000L,$
     offset:0L,$
     pixmap_wid:0L,$
     plotwin_size:[512,512],$
     plotwin_wid:0L,$
     plotxscale:!x.s,$
     plotyscale:!y.s,$
     red:ptr_new(fltarr(2)),$
     reg:[[!values.f_nan,!values.f_nan],[!values.f_nan,!values.f_nan]],$
     stdimage:1024.,$
     tmpdevpos:[0.,0.],$
     zoom:0.}

d = {bytesclimage:ptr_new(fltarr(2,2)),$
     dblclick:0.2,$
     image:ptr_new(fltarr(2)),$
     imagemax:0.,$
     imagemin:0.,$
     image_size:[0,0],$
     hdr:ptr_new(strarr(2)),$
     path:''}

state = {w:w,p:p,d:d}

font = '-adobe-helvetica-bold-r-normal--14-140-75-75-p-82-iso8859-1'

state.w.ximgtool_base = widget_base(TITLE='XIMGTOOL',$
                                /COLUMN,$
                                /TLB_SIZE_EVENTS,$
                                GROUP_LEADER=group_leader)
      
   button_row = widget_base(state.w.ximgtool_base,$
                            /ROW,$
                            EVENT_PRO='ximgtool_event',$
                            /BASE_ALIGN_CENTER)

      desc = ['1\File','0\ReadFits','0\ImageMath','2\Quit']
      file = cw_pdmenu(button_row,$
                       desc,$
                       /RETURN_NAME,$
                       FONT=font,$
                       UVALUE='File')

      desc = ['1\View','1\ColorMap','0\Grey','0\Heat','0\Rainbow',$
              '2\Blue-White','1\Scaling','0\Linear','2\Hist Eq','1\Range',$
              '0\Full Range','2\Auto Range','1\Rotate',$
              '0\-Y to +Y','0\-X to +X','0\-90','0\-180','2\-270']
      view = cw_pdmenu(button_row,$
                       desc,$
                       /RETURN_NAME,$
                       FONT=font,$
                       UVALUE='View')

      desc = ['1\Options','2\Image Header']
      options = cw_pdmenu(button_row,$
                          desc,$
                          /RETURN_NAME,$
                          FONT=font,$
                          UVALUE='Options')

      zoom1 = widget_button(button_row,$
                            FONT=font,$
                            VALUE='Zoom 1',$
                            UVALUE='Zoom 1')

      center = widget_button(button_row,$
                             FONT=font,$
                             VALUE='Center',$
                             UVALUE='Center')

      help = widget_button(button_row,$
                           FONT=font,$
                           VALUE='Help',$
                           UVALUE='Help')

   state.w.keyboard = widget_text(state.w.ximgtool_base, $
                                  /all_events, $
                                  scr_xsize = 1, $
                                  scr_ysize = 1, $
                                  uvalue = 'Keyboard', $
                                  event_pro='ximgtool_event',$
                                  value = '')

   state.w.track = widget_text(state.w.ximgtool_base, $
                               YSIZE=1)

   plot_base = widget_base(state.w.ximgtool_base,$
                           /COLUMN)
         
      state.w.plotwin = widget_draw(plot_base,$
                                    /align_center,$
                                    xsize=state.p.plotwin_size[0],$
                                    ysize=state.p.plotwin_size[1],$
                                    event_pro = 'ximgtool_plotwinevent',$
                                    /TRACKING_EVENTS,$
                                    /motion_events,$
                                    /button_events)

      state.w.cbarwin = widget_draw(plot_base,$
                                    /ALIGN_CENTER,$
                                    ysize=10,$
                                    xsize=state.p.plotwin_size[0])
      

mkct, 3, BOT=offset,RED=red,GREEN=green,BLUE=blue
state.p.offset = offset
*state.p.red   = red
*state.p.green = green
*state.p.blue  = blue

; Get things running.

centertlb,state.w.ximgtool_base
      
widget_control, state.w.ximgtool_base, /Realize

;  Get plotwin ids

widget_control, state.w.plotwin,  get_value = x
state.p.plotwin_wid = x
wid = x

widget_control, state.w.cbarwin,  get_value = x
state.p.cbarwin_wid = x

window, /free, /pixmap,xsize=state.p.plotwin_size[0],$
  ysize=state.p.plotwin_size[1]
state.p.pixmap_wid = !d.window

;  Get sizes for things.

widget_geom = widget_info(state.w.ximgtool_base, /geometry)

state.p.buffer[0]=widget_geom.xsize-state.p.plotwin_size[0]
state.p.buffer[1]=widget_geom.ysize-state.p.plotwin_size[1]


; Start the Event Loop. This will be a non-blocking program.

XManager, 'ximgtool', $
  state.w.ximgtool_base, $
  EVENT_HANDLER='ximgtool_resize',$
  /No_Block,$
  cleanup = 'ximgtool_cleanup'

ximgtool_colorbar

end
;
;******************************************************************************
;
pro ximgtool_controlpanel

common ximgtool_state

textfont   = '-adobe-helvetica-medium-r-normal--0-0-75-75-p-0-iso8859-1'
buttonfont = '-adobe-helvetica-bold-r-normal--14-140-75-75-p-82-iso8859-1'

if not xregistered('xcompspec_cp') then begin

    cp_base = widget_base(group_leader = state.w.ximgtool_base, $
                          /COLUMN, $
                          title ='Control Panel')

    value = ['Grey','Heat','Rainbow','Blue-White']
    colormap = widget_droplist(cp_base,$              
                               FONT=buttonfont,$
                               TITLE='Color Map: ',$
                               VALUE=value,$
                               UVALUE='Color Map')

    scaling = cw_bgroup(cp_base,$
                        font=buttonfont,$
                        ['Linear','Hist Eq'],$
                        /ROW,$
                        /RETURN_NAME,$
                        /NO_RELEASE,$
                        /EXCLUSIVE,$
                        LABEL_LEFT='Scaling:',$
                        UVALUE='Scaling',$
                        SET_VALUE=0)

    value = ['-Y to +Y','-X to +X','-90','-180','-270']
    rotation = widget_droplist(cp_base,$              
                               FONT=buttonfont,$
                               TITLE='Roation: ',$
                               VALUE=value,$
                               UVALUE='Roation')
    
    quit = widget_button(cp_base,$
                         VALUE='Done',$
                         FONT=buttonfont,$
                         UVALUE='Done')

    centertlb,cp_base
   
    widget_control, cp_base, /Realize
    
; Start the Event Loop. This will be a non-blocking program.
    
    XManager, 'ximgtool_cp', $
      cp_base, $
      /No_Block,$
      event_handler='ximgtool_event'


endif


end
;
;******************************************************************************
;
pro ximgtool_autoscale

common ximgtool_state

if n_elements(*state.d.image) gt 1000. then begin

    cols = randomn(0.5,state.d.image_size[0]*.1,/UNIFORM)*state.d.image_size[0]
    subimage = (*state.d.image)[cols,*]
    z = where(finite(subimage) eq 1)
    moments,subimage[z],mean,var,std

endif else begin

    z = where(finite( (*state.d.image)) eq 1)
    moments,(*state.d.image)[z],mean,var,std

endelse

state.d.imagemax = ( mean + (3.*std) )  < max(*state.d.image,/NAN)
state.d.imagemin = ( mean - (3.*std) )  > min(*state.d.image,/NAN)

if state.d.imagemin ge state.d.imagemax then begin

    state.d.imagemin = state.d.imagemin-1
    state.d.imagemax = state.d.imagemax+1

endif

end
;
;*****************************************************************************
;
pro ximgtool_cleanup,event

common ximgtool_state

ptr_free, state.p.blue
ptr_free, state.p.green
ptr_free, state.p.red
ptr_free, state.d.bytesclimage
ptr_free, state.d.image

state = 0B

end
;
;*****************************************************************************
;
pro ximgtool_color,event,BRIGHTNESS=brightness,CONTRAST=contrast

common ximgtool_state

pwin = state.p.plotwin_size

if n_elements(BRIGHTNESS) eq 0 then begin

    x = 1 > event.x < pwin[0]
    y = 1 > event.y < pwin[1]

    brightness = long ( (pwin[1]-y) * (state.p.maxbandc)/pwin[1])
    contrast   = long ( x * (state.p.maxbandc)/pwin[0])

    state.p.brightness = brightness
    state.p.contrast   = contrast

endif 

d = !d.table_size-state.p.offset-1

maxdp = 600
mindp = 4

if (contrast LT (state.p.maxbandc / 2)) then begin
    dp = ((d - maxdp) / float((state.p.maxbandc / 2) - 1)) * contrast + $
      ((maxdp * state.p.maxbandc / 2) - d) / float(state.p.maxbandc / 2)
endif else begin
    dp = ((mindp - d) / float(state.p.maxbandc / 2)) * contrast + $
      ((d * state.p.maxbandc) - (mindp * state.p.maxbandc / 2)) / $
      float(state.p.maxbandc / 2)
endelse

dp =  fix(dp)

r = replicate( (*state.p.red)[d-1]  , 2*d + dp)
g = replicate( (*state.p.green)[d-1], 2*d + dp)
b = replicate( (*state.p.blue)[d-1] , 2*d + dp)

r[0:d-1] = (*state.p.red)[0]
g[0:d-1] = (*state.p.green)[0]
b[0:d-1] = (*state.p.blue)[0]

a = findgen(d)

r[d] = congrid(*state.p.red, dp)
g[d] = congrid(*state.p.green, dp)
b[d] = congrid(*state.p.blue, dp)

bshift = round(brightness * (d+dp) / float(state.p.maxbandc))

rr = r[a + bshift] 
gg = g[a + bshift]
bb = b[a + bshift]

tvlct, rr, gg, bb, state.p.offset

end
;
;*****************************************************************************
;
pro ximgtool_colorbar

common ximgtool_state

b = cmcongrid( findgen(!d.n_colors-state.p.offset-1), $
               state.p.plotwin_size[0]) + state.p.offset
c = replicate(1,10)
a = b # c


wset,state.p.cbarwin_wid
tv, a

end
;
;*****************************************************************************
;
pro ximgtool_displayimage,CENTER=center

common ximgtool_state

;  Get zoom window size.

zoom_factor = 2.^state.p.zoom
zwin_size   = state.p.plotwin_size / zoom_factor * state.p.dev2img
dev_offset  = (zwin_size-floor(zwin_size)) * zoom_factor / state.p.dev2img / 2.
zwin_size   = floor(zwin_size)
pwin_size   = round(state.p.plotwin_size-dev_offset)

;  Get limits of image for zoom window.

xyll        = roundgt(state.p.cenpix - zwin_size/2. )  ; XY lower left
xyur        = xyll+zwin_size-1
xyll_img    = xyll > 0.
xyur_img    = fltarr(2)
xyur_img[0] = xyur[0] < (state.d.image_size[0]-1)
xyur_img[1] = xyur[1] < (state.d.image_size[1]-1)

zwin_imgsize = xyur_img-xyll_img+1
zwin_offset  = xyll_img-xyll

pwin_imgsize = round( (pwin_size/float(zwin_size))*zwin_imgsize)
pwin_offset  = round( (pwin_size/float(zwin_size))*zwin_offset)


tmpimage = cmcongrid((*state.d.bytesclimage)[xyll_img[0]:xyur_img[0],$
                                             xyll_img[1]:xyur_img[1]],$
                     pwin_imgsize[0],pwin_imgsize[1])


dev_offset = pwin_offset+dev_offset

wset, state.p.pixmap_wid
erase
tv, tmpimage,dev_offset[0],dev_offset[1],/DEVICE

xrange = xyll_img[0]+[0,zwin_imgsize[0]]-0.5
yrange = xyll_img[1]+[0,zwin_imgsize[1]]-0.5

plot,indgen(10),/nodata,/noerase,xsty=5,ysty=5,xrange=xrange,yrange=yrange,$
  xmargin=[0,0],ymargin=[0,0],color=2,noclip=0,/device,$
  position=[dev_offset[0],dev_offset[1],$
            dev_offset[0]+pwin_imgsize[0],$
            dev_offset[1]+pwin_imgsize[1]]

state.p.plotxscale = !x.s
state.p.plotyscale = !y.s

wset, state.p.plotwin_wid
erase
device, copy=[0,0,state.p.plotwin_size[0],state.p.plotwin_size[1],0,0,$
              state.p.pixmap_wid]


if keyword_set(CENTER) then tvcrs,roundgt(state.p.cenpix[0]),$
  roundgt(state.p.cenpix[1]),/DATA

widget_control, state.w.keyboard, /INPUT_FOCUS, /SENSITIVE

end
;
;******************************************************************************
;
pro ximgtool_hdr

common ximgtool_state

font = '-adobe-helvetica-bold-r-normal--14-140-75-75-p-82-iso8859-1'

if not (xregistered('ximgtool_hdrinfo')) then begin

    state.w.hdr_base = widget_base(group_leader = state.w.ximgtool_base, $
                                   /column, $
                                   title='FITS Header',$
                                   uvalue = 'headinfo_base')

    state.w.hdr_text = widget_text(state.w.hdr_base, $
                                   /scroll, $
                                   font='7x14',$
                                   value = (*state.d.hdr), $
                                   xsize = 85, $
                                   ysize = 24)
    
    button = widget_button(state.w.hdr_base, $
                           FONT=font,$
                           value = 'Done',$
                           event_pro = 'ximgtool_quit')
    
    widget_control, state.w.hdr_base, /realize
    XManager, 'xqtv_hdrinfo', $
      state.w.hdr_base, $
      /No_Block

endif else begin

    widget_control, state.w.hdr_text, set_value=(*state.d.hdr)

endelse

end
;
;*****************************************************************************
;
pro ximgtool_linecut

common ximgtool_state

!x.s = state.p.plotxscale
!y.s = state.p.plotyscale

p1 = convert_coord(state.p.reg[*,0],/DEVICE,/TO_DATA)
p2 = convert_coord(state.p.reg[*,1],/DEVICE,/TO_DATA)

nPoints = ABS(p2[0]-p1[0]+1) > ABS(p2[1]-p1[1]+1)

xloc = p1[0] + (p2[0] - p1[0]) * Findgen(nPoints) / (nPoints - 1)
yloc = p1[1] + (p2[1] - p1[1]) * Findgen(nPoints) / (nPoints - 1)

z = where(xloc gt 0 and yloc gt 0 and xloc lt state.d.image_size[0] and $
          yloc lt state.d.image_size[1])


profile = Interpolate(*state.d.image, xloc, yloc)

xzoomplot,findgen(n_elements(profile)),profile

state.p.reg[*] = !values.f_nan


end
;
;******************************************************************************
;
pro ximgtool_quit,event

common ximgtool_state

widget_control, event.top, /destroy

end
;
;*****************************************************************************
;
pro ximgtool_readfits

common ximgtool_state

if state.d.path eq '' then begin
    
    fullpath = dialog_pickfile(dialog_parent=state.w.ximgtool_base,$
                               filter='*.fits',get_path=newpath,$
                               /must_exist)
    state.d.path =newpath
    
endif else begin
    
    fullpath = dialog_pickfile(dialog_parent=state.w.ximgtool_base,$
                               filter='*.fits',path=state.d.path,$
                               get_path=newpath,/must_exist)          
    state.d.path = newpath
    
endelse
if fullpath eq '' then goto, cont
*state.d.image = readfits(fullpath,hdr)
*state.d.hdr = hdr
s = size(*state.d.image)
state.d.image_size = [s[1],s[2]]
ximgtool_autoscale
ximgtool_scaleimage
ximgtool_displayimage
str = 'ximgtool - '+strmid(fullpath,strpos(fullpath,'/',/REVERSE_S)+1)
widget_control, state.w.ximgtool_base, tlb_set_title = str
cont:

widget_control, state.w.keyboard, /INPUT_FOCUS, /SENSITIVE

end
;
;*****************************************************************************
;
pro ximgtool_scaleimage

common ximgtool_state

ncolors = !d.table_size-(state.p.offset+1)

case state.p.imagescaling of 


    'Linear': *state.d.bytesclimage = bytscl(*state.d.image,$
                                             /NAN,$
                                             min = state.d.imagemin,$
                                             max = state.d.imagemax,$
                                             top = ncolors-1) + state.p.offset
    

    'Hist Eq': *state.d.bytesclimage = bytscl(hist_equal(*state.d.image, $
                                                       minv=state.d.imagemin,$
                                                       maxv=state.d.imagemax),$
                              /NAN,top = ncolors-1) + state.p.offset

endcase

end
;
;******************************************************************************
;
; ------------------------------Event Handlers-------------------------------- 
;
;******************************************************************************
;
pro ximgtool_event,event

common ximgtool_state

widget_control, event.id, get_uvalue=uval
widget_control, /hourglass

case uval of

    'Center': begin

        state.p.cenpix = state.d.image_size/2.-0.5
        ximgtool_displayimage

    end

    'Done': widget_control, event.top, /DESTROY

    'Help':

    'File': begin

        case event.value of 

            'ImageMath': ximgmath,group_leader=state.w.ximgtool_base

            'ReadFits': ximgtool_readfits
            
            'Quit': ximgtool_quit,event

        endcase
       
    end

    'Keyboard': begin

        case strtrim(event.ch,2) of 
            
            'c': begin

                state.p.cursormode = 'None'
                state.p.reg[*] = !values.f_nan
                ximgtool_displayimage

            end
            
            'f': ximgtool_readfits

            'i': begin          
                
                state.p.zoom = state.p.zoom+1
                ximgtool_displayimage
                
            end
            'o': begin

                state.p.zoom = state.p.zoom-1
                ximgtool_displayimage

            end

            'm': ximgtool_controlpanel
            
            'l': state.p.cursormode = 'Line Cut'

            else:

        endcase

    end

;    'Options': begin
        
;        case event.value of 

;            'Image Header': ximgtool_hdr

;        endcase

;    end

    'Color Map': begin

        case event.index of 

            3: begin ; Blue-White
                
                mkct, 1,RED=red,GREEN=green,BLUE=blue
                *state.p.red   = red
                *state.p.green = green
                *state.p.blue  = blue
                ximgtool_color,BRIGHTNESS=state.p.brightness,$
                  CONTRAST=state.p.contrast
            end            
            
            0: begin ; Grey
                
                mkct, 0,RED=red,GREEN=green,BLUE=blue
                *state.p.red   = red
                *state.p.green = green
                *state.p.blue  = blue
                ximgtool_color,BRIGHTNESS=state.p.brightness,$
                  CONTRAST=state.p.contrast

            end

            1: begin ; Heat
                
                mkct, 3,RED=red,GREEN=green,BLUE=blue
                *state.p.red   = red
                *state.p.green = green
                *state.p.blue  = blue
                ximgtool_color,BRIGHTNESS=state.p.brightness,$
                  CONTRAST=state.p.contrast
                
            end

            2: begin ; Rainbow
                
                mkct, 13,RED=red,GREEN=green,BLUE=blue
                *state.p.red   = red
                *state.p.green = green
                *state.p.blue  = blue
                ximgtool_color,BRIGHTNESS=state.p.brightness,$
                  CONTRAST=state.p.contrast
                
            end
            
        endcase

    end

    'Rotation': begin

        case event.value of 

            '-X to +X': begin
                
                *state.d.image = rotate(*state.d.image,5)
                ximgtool_scaleimage
                ximgtool_displayimage
                
            end
            '-Y to +Y': begin
                
                *state.d.image = rotate(*state.d.image,7)
                ximgtool_scaleimage
                ximgtool_displayimage
                
            end
            
            '-90': begin
                
                *state.d.image = rotate(*state.d.image,1)
                ximgtool_scaleimage
                ximgtool_displayimage
                
            end
            
            '-180': begin
                
                *state.d.image = rotate(*state.d.image,2)
                ximgtool_scaleimage
                ximgtool_displayimage
                
            end
            
            '-270': begin
                
                *state.d.image = rotate(*state.d.image,3)
                ximgtool_scaleimage
                ximgtool_displayimage
                
            end            

        endcase

    end

    'Scaling': begin

        case event.value of 

            'Linear': begin

                state.p.imagescaling = 'Linear'
                ximgtool_scaleimage
                ximgtool_displayimage

            end

            'Hist Eq': begin

                state.p.imagescaling = 'Hist Eq'
                ximgtool_scaleimage
                ximgtool_displayimage

            end

        endcase
        
    end
    

    'View': begin

        case event.value of 

            'Auto Range': begin
                
                ximgtool_autoscale
                ximgtool_scaleimage
                ximgtool_displayimage
                
            end
            'Blue-White': begin
                
                mkct, 1,RED=red,GREEN=green,BLUE=blue
                *state.p.red   = red
                *state.p.green = green
                *state.p.blue  = blue
                
            end            
            'Full Range': begin
                
                state.d.imagemax = max(*state.d.image,/NAN)
                state.d.imagemin = min(*state.d.image,/NAN)
                ximgtool_scaleimage
                ximgtool_displayimage
                
            end
            'Grey': begin
                
                mkct, 0,RED=red,GREEN=green,BLUE=blue
                *state.p.red   = red
                *state.p.green = green
                *state.p.blue  = blue

            end
            'Heat': begin
                
                mkct, 3,RED=red,GREEN=green,BLUE=blue
                *state.p.red   = red
                *state.p.green = green
                *state.p.blue  = blue
                
            end
            'Hist Eq': begin
                
                state.p.imagescaling = 'Hist Eq'
                ximgtool_scaleimage
                ximgtool_displayimage
                
            end
            'Linear': begin

                state.p.imagescaling = 'Linear'
                ximgtool_scaleimage
                ximgtool_displayimage                
                
            end
            'Rainbow': begin
                
                mkct, 13,RED=red,GREEN=green,BLUE=blue
                *state.p.red   = red
                *state.p.green = green
                *state.p.blue  = blue
                
            end
            '-X to +X': begin
                
                *state.d.image = rotate(*state.d.image,5)
                ximgtool_scaleimage
                ximgtool_displayimage
                
            end
            '-Y to +Y': begin
                
                *state.d.image = rotate(*state.d.image,7)
                ximgtool_scaleimage
                ximgtool_displayimage
                
            end
            
            '-90': begin
                
                *state.d.image = rotate(*state.d.image,1)
                ximgtool_scaleimage
                ximgtool_displayimage
                
            end
            
            '-180': begin
                
                *state.d.image = rotate(*state.d.image,2)
                ximgtool_scaleimage
                ximgtool_displayimage
                
            end
            
            '-270': begin
                
                *state.d.image = rotate(*state.d.image,3)
                ximgtool_scaleimage
                ximgtool_displayimage
                
            end            
            
        endcase

    end
    'Zoom 1': begin

        state.p.zoom = 0
        ximgtool_displayimage

    end

endcase

end
;
;*****************************************************************************
;
pro ximgtool_plotwinevent,event

common ximgtool_state

wset, state.p.plotwin_wid

;  Check to see if it is a TRACKING event.

if strtrim(tag_names(event,/STRUCTURE_NAME),2) eq 'WIDGET_TRACKING' then begin

    if event.enter eq 0 then widget_control, state.w.keyboard, SENSITIVE=0
    goto, cont
    
endif

;  If not, set the keyboard focus and active window.

widget_control, state.w.keyboard, /INPUT_FOCUS, /SENSITIVE

!x.s = state.p.plotxscale
!y.s = state.p.plotyscale

if TAG_NAMES(event,/STRUCTURE) eq 'WIDGET_TIMER' then begin

    if state.p.firstclick eq 1 then begin

        state.p.cenpix = (convert_coord(state.p.tmpdevpos[0],$
                                        state.p.tmpdevpos[1],$
                                        /DEVICE,/TO_DATA))[0:1]
        state.p.firstclick=0
        ximgtool_displayimage,/CENTER
        goto, cont

    endif

endif else begin

    if event.type eq 2 then begin

;  Update cursor position

        pix  = (convert_coord(event.x,event.y,/device,/to_data))[0:1]
        zpix = roundgt(pix)
        
        if pix[0] gt state.d.image_size[0]-0.5 or pix[0] lt -0.5 or $
          pix[1] gt state.d.image_size[1]-0.5 or pix[1] lt -0.5 then $
          z = 0. else $
          z = (*state.d.image)[zpix[0],zpix[1]]      
        
        string = strjoin( [string(pix,format='(f6.1)'), $
                           string(z,format='(f9.2)')],' ')
        
        widget_control, state.w.track,SET_VALUE=string
        

    endif


    case state.p.cursormode of 

        'Color': begin

            if event.release gt 1 then begin

                state.p.cursormode = 'None'
                goto, cont
                
            endif

            ximgtool_color,event

        end

        'Line Cut': begin

            if event.press eq 1 and event.type eq 0 then begin

                state.p.reg[*,0] = [event.x,event.y]
                goto, cont

            endif
            if event.release eq 1 and event.type eq 1 then begin

                state.p.reg[*,1] = [event.x,event.y]
                wset, state.p.pixmap_wid
                plots,[state.p.reg[0,0],state.p.reg[0,1]],$
                  [state.p.reg[1,0],state.p.reg[1,1]],/DEVICE,color=3,THICK=2
                state.p.cursormode = 'None'
                ximgtool_linecut

                goto, cont

            endif 
            if finite(state.p.reg[0]) then plots,[state.p.reg[0,0],event.x],$
              [state.p.reg[1,0],event.y],/DEVICE,color=3,THICK=2

        end

        'Move': begin

            if event.type eq 1 then begin
                
                state.p.cursormode = 'None'
                goto, cont
        
            endif

            if state.p.cursormode eq 'Move' then begin
                
                state.p.cursor = (convert_coord(event.x,event.y,$
                                                /DEVICE,/TO_NORM))[0:1]
                pix  = (convert_coord(event.x,event.y,/device,/to_data))[0:1]
                zpix = roundgt(pix)
                
                if pix[0] gt state.d.image_size[0]-0.5 or pix[0] lt -0.5 or $
                  pix[1] gt state.d.image_size[1]-0.5 or pix[1] lt -0.5 then $
                  z = 0. else z = (*state.d.image)[zpix[0],zpix[1]]      
                
                string = strjoin( [string(pix,format='(f6.1)'), $
                                   string(z,format='(f8.2)')],' ')
                
                wset, state.p.plotwin_wid
                device, copy=[0,0,state.p.plotwin_size[0],$
                              state.p.plotwin_size[1],0,0,state.p.pixmap_wid]
                
                xyouts,state.p.cursor[0],state.p.cursor[1],$
                  string,/NORM,color=5,ALIGNMENT=0.5,charsize=1.5,charthick=1.5
                goto, cont
                
            endif

        end
        
        'None': begin

            if event.press gt 1 then begin
                
                state.p.cursormode = 'Color'
                goto, cont
                
            endif
            if event.release gt 1 then begin
                
                state.p.cursormode = 'None'
                goto, cont
                
            endif
            
            if event.type eq 0 and state.p.firstclick eq 0 then begin
            
                state.p.tmpdevpos = [event.x,event.y]
                state.p.firstclick = 1
                widget_control, event.id, TIMER=state.d.dblclick
                goto, cont
                
            endif
            
            if event.type eq 0 and state.p.firstclick eq 1 then begin
                
                state.p.zoom   = state.p.zoom+1
                state.p.cenpix = (convert_coord(event.x,event.y,/DEVICE,$
                                                /TO_DATA))[0:1]
                state.p.firstclick=0
                ximgtool_displayimage,/CENTER
                goto, cont
                
            endif
            
        end

    endcase

endelse

cont:

end
;
;******************************************************************************
;
pro ximgtool_resize, event

common ximgtool_state

widget_control, state.w.ximgtool_base, tlb_get_size = size

state.p.plotwin_size[0]=size[0]-state.p.buffer[0]
state.p.plotwin_size[1]=size[1]-state.p.buffer[1]

widget_control, state.w.plotwin, draw_xsize=state.p.plotwin_size[0]
widget_control, state.w.plotwin, draw_ysize=state.p.plotwin_size[1]

widget_control, state.w.cbarwin, draw_xsize=state.p.plotwin_size[0]
wset, state.p.plotwin_wid
erase

wdelete,state.p.pixmap_wid
window, /FREE, /PIXMAP,XSIZE=state.p.plotwin_size[0],$
  YSIZE=state.p.plotwin_size[1]
state.p.pixmap_wid = !d.window

ximgtool_displayimage,/CENTER
ximgtool_colorbar

end
;
;******************************************************************************
;
; ------------------------------Main Program-------------------------------- 
;
;******************************************************************************
;
pro ximgtool,image,hdr,GROUP_LEADER=group_leader,WID=wid,MINMAX=minmax,$
        STDIMAGE=stdimage

common ximgtool_state

if not xregistered('ximgtool') then ximgtool_startup,WID=wid,$
  GROUP_LEADER=group_leader else wid = state.p.plotwin_wid

if n_params() eq 2 then begin

    zparcheck, 'ximgtool', image, 1, [2,3,4,5], 2, 'Image' 
    zparcheck, 'ximgtool', hdr, 2, 7, 1, 'Hdr' 
    
    *state.d.image      = image
    state.d.image_size  = (size(image))[1:2]
    widget_control, state.w.ximgtool_base, tlb_set_title = 'ximgtool'

endif 
if n_params() eq 1 then begin

    if size(image,/TYPE) eq 7 then begin

        *state.d.image = readfits(strtrim(image,2),hdr)
        *state.d.hdr = hdr
        state.d.image_size = (size(*state.d.image))[1:2]
        str = 'ximgtool - '+strmid(image,strpos(image,'/',/REVERSE_S)+1)
        widget_control, state.w.ximgtool_base, tlb_set_title = str
        
    endif else begin

        zparcheck, 'ximgtool', image, 1, [2,3,4,5], 2, 'Image' 
        *state.d.image      = image
        state.d.image_size  = (size(image))[1:2]
        widget_control, state.w.ximgtool_base, tlb_set_title = 'ximgtool'

        
    endelse

endif 

if n_params() eq 0 then begin

    (*state.d.image)   = findgen(1024,1024)/1e6
    state.d.image_size = (size(*state.d.image))[1:2]
    widget_control, state.w.ximgtool_base, tlb_set_title = 'ximgtool'

endif

if n_elements(stdimage) ne 0 then state.p.stdimage = stdimage

state.p.dev2img = state.p.stdimage/512.
state.p.cenpix = state.d.image_size/2.-0.5

if n_elements(MINMAX) ne 0 then begin

    state.p.imagemax = minmax[1]
    state.p.imagemin = minmax[0]

endif else ximgtool_autoscale

ximgtool_scaleimage
ximgtool_displayimage

end








